## mingw-w64-mdds-3.0.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
cmake_policy(SET CMP0048 NEW)

project(mdds VERSION 3.0.0 LANGUAGES CXX)
set(API_VERSION 3.0)
set(CMAKE_CXX_STANDARD 17)

find_package(Boost)
find_package(Threads)

enable_testing()
set(CMAKE_CTEST_COMMAND ctest -V)

message(STATUS "size of void pointer: ${CMAKE_SIZEOF_VOID_P}")

add_compile_definitions(
    MDDS_UNIT_TEST
    MDDS_DEBUG_NODE_BASE
    SIZEOF_VOID_P=${CMAKE_SIZEOF_VOID_P}
)

if(MSVC)
    add_definitions(/wd4251 /wd4275 /wd4244 /MP)
endif(MSVC)

include_directories(
    ${PROJECT_SOURCE_DIR}/include
    ${Boost_INCLUDE_DIR}
)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

install(DIRECTORY
    ${PROJECT_SOURCE_DIR}/include/mdds
    DESTINATION include/mdds-${API_VERSION}
    FILES_MATCHING
        PATTERN "*.hpp"
        PATTERN "*.inl"
)

add_subdirectory(test)
add_subdirectory(tools)

=== test/CMakeLists.txt ===

add_library(test-global STATIC EXCLUDE_FROM_ALL test_global.cpp)

target_include_directories(test-global PUBLIC
    include
)

add_subdirectory(flat_segment_tree)
add_subdirectory(multi_type_vector)
add_subdirectory(multi_type_matrix)
add_subdirectory(point_quad_tree)
add_subdirectory(rtree)
add_subdirectory(segment_tree)
add_subdirectory(sorted_string_map)
add_subdirectory(trie_map)

=== test/multi_type_matrix/CMakeLists.txt ===

add_executable(multi-type-matrix-test-main EXCLUDE_FROM_ALL
    test_main.cpp
)

add_executable(multi-type-matrix-test-walk EXCLUDE_FROM_ALL
    test_walk.cpp
)

target_link_libraries(multi-type-matrix-test-main PRIVATE test-global)
target_link_libraries(multi-type-matrix-test-walk PRIVATE test-global)

add_test(multi-type-matrix-test-main multi-type-matrix-test-main)
add_test(multi-type-matrix-test-walk multi-type-matrix-test-walk)

add_dependencies(check
    multi-type-matrix-test-main
    multi-type-matrix-test-walk
)

=== test/multi_type_vector/CMakeLists.txt ===

add_subdirectory(default)
add_subdirectory(collection)
add_subdirectory(custom)
add_subdirectory(custom-trait)
add_subdirectory(debug-util)
add_subdirectory(element-blocks)
add_subdirectory(event)
add_subdirectory(perf)

=== test/point_quad_tree/CMakeLists.txt ===

add_executable(point-quad-tree-test-main EXCLUDE_FROM_ALL
    test_main.cpp
)

target_link_libraries(point-quad-tree-test-main PRIVATE test-global)

add_test(point-quad-tree-test-main point-quad-tree-test-main)

add_dependencies(check
    point-quad-tree-test-main
)

=== test/segment_tree/CMakeLists.txt ===

add_executable(segment-tree-test-main EXCLUDE_FROM_ALL
    test_main.cpp
    test_move_value.cpp
)

target_link_libraries(segment-tree-test-main PRIVATE test-global)

add_test(segment-tree-test-main segment-tree-test-main)

add_dependencies(check
    segment-tree-test-main
)

=== test/sorted_string_map/CMakeLists.txt ===
set(TEST_NAME sorted-string-map-test)
set(TARGET_NAME ${TEST_NAME})

add_executable(${TARGET_NAME} EXCLUDE_FROM_ALL
    test_main.cpp
)

target_link_libraries(${TARGET_NAME} PUBLIC test-global)

add_test(${TEST_NAME} ${TARGET_NAME})
add_dependencies(check ${TARGET_NAME})

=== test/trie_map/CMakeLists.txt ===

add_executable(trie-map-test-main EXCLUDE_FROM_ALL
    test_main.cpp
    test_state.cpp
    test_node.cpp
    test_move_value.cpp
    test_pack_value_type.cpp
)

target_link_libraries(trie-map-test-main PRIVATE test-global)

add_test(trie-map-test-main trie-map-test-main)

add_dependencies(check
    trie-map-test-main
)

=== tools/runtime-env/CMakeLists.txt ===

add_executable(runtime-env EXCLUDE_FROM_ALL main.cpp)
target_include_directories(runtime-env PRIVATE ${PROJECT_SOURCE_DIR}/include)

=== test/multi_type_vector/custom-trait/CMakeLists.txt ===
add_subdirectory(aos)
add_subdirectory(soa)

=== test/multi_type_vector/element-blocks/CMakeLists.txt ===
set(TEST_NAME multi-type-vector-test-element-blocks)
set(TARGET_NAME ${TEST_NAME})

add_executable(${TARGET_NAME} EXCLUDE_FROM_ALL
    test_main.cpp
    test_basic.cpp
    test_std_vector_bool.cpp
    test_store_types.cpp
    test_functions.cpp
)

add_executable(${TARGET_NAME}-aos EXCLUDE_FROM_ALL
    test_aos.cpp
    test_aos.cpp
    test_no_standard_blocks_aos.cpp
)

add_executable(${TARGET_NAME}-soa EXCLUDE_FROM_ALL
    test_soa.cpp
    test_soa.cpp
    test_no_standard_blocks_soa.cpp
)

target_link_libraries(${TARGET_NAME} PUBLIC test-global)
target_link_libraries(${TARGET_NAME}-aos PUBLIC test-global)
target_link_libraries(${TARGET_NAME}-soa PUBLIC test-global)

add_test(${TEST_NAME} ${TARGET_NAME})
add_test(${TEST_NAME}-aos ${TARGET_NAME})
add_test(${TEST_NAME}-soa ${TARGET_NAME})
add_dependencies(check ${TARGET_NAME})

=== test/multi_type_vector/collection/aos/CMakeLists.txt ===
set(TEST_NAME multi-type-vector-test-collection-aos)
set(TARGET_NAME ${TEST_NAME})

add_executable(${TARGET_NAME} EXCLUDE_FROM_ALL
    test_main.cpp
)

target_link_libraries(${TARGET_NAME} PUBLIC test-global)
target_include_directories(${TARGET_NAME} PUBLIC
    ../tc
    ../../../include
)

add_test(${TEST_NAME} ${TARGET_NAME})
add_dependencies(check ${TARGET_NAME})

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=mdds
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.0.0
pkgrel=1
pkgdesc="A collection of Multi-Dimensional Data Structure and indexing algorithm. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://gitlab.com/mdds/mdds'
msys2_references=(
  'archlinux: mdds'
)
license=('spdx:MIT')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-autotools")
checkdepends=("${MINGW_PACKAGE_PREFIX}-boost")
source=("https://gitlab.com/mdds/mdds/-/archive/${pkgver}/${_realname}-${pkgver}.tar.bz2")
sha256sums=('2d056dbec3a3a16c48e3451532ff53afe8fc23ed1f56bed4191197fa99a4b202')

prepare() {
  cd ${_realname}-${pkgver}

  autoreconf -fiv
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  ../${_realname}-${pkgver}/configure \
      --prefix=${MINGW_PREFIX}

  make
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  make check
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" make install

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
